#define MPRIS_DBUS_NAME "org.mpris.deadbeef"
#define MPRIS_INTERFACE "org.freedesktop.MediaPlayer"
#define MPRIS_PATH_ROOT "/"
#define MPRIS_PATH_PLAYER "/Player"
#define MPRIS_PATH_TRACKLIST "/TrackList"

typedef struct {
	char *tag;
	int type;
	char *db_tag;
} mpris_meta;

const char* MPRIS_ROOT_XML="<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\"\n\
\"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n\
<node>\n\
  <interface name=\"org.freedesktop.DBus.Introspectable\">\n\
    <method name=\"Introspect\">\n\
      <arg name=\"introspection_xml\" direction=\"out\" type=\"s\"/>\n\
    </method>\n\
  </interface>\n\
  <interface name=\"org.freedesktop.MediaPlayer\">\n\
    <method name=\"Identity\">\n\
      <arg type=\"s\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"MprisVersion\">\n\
      <arg type=\"(qq)\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"Quit\">\n\
    </method>\n\
  </interface>\n\
  <node name=\"Player\"/>\n\
  <node name=\"TrackList\"/>\n\
</node>";

const char* MPRIS_PLAYER_XML="<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\"\n\
\"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n\
<node>\n\
  <interface name=\"org.freedesktop.DBus.Introspectable\">\n\
    <method name=\"Introspect\">\n\
      <arg name=\"introspection_xml\" direction=\"out\" type=\"s\"/>\n\
    </method>\n\
  </interface>\n\
  <interface name=\"org.freedesktop.MediaPlayer\">\n\
    <signal name=\"CapsChange\">\n\
      <arg type=\"i\" direction=\"out\"/>\n\
    </signal>\n\
    <signal name=\"TrackChange\">\n\
      <arg type=\"a{sv}\" direction=\"out\"/>\n\
    </signal>\n\
    <signal name=\"StatusChange\">\n\
      <arg type=\"(iiii)\" direction=\"out\"/>\n\
    </signal>\n\
    <method name=\"Next\">\n\
    </method>\n\
    <method name=\"Prev\">\n\
    </method>\n\
    <method name=\"Pause\">\n\
    </method>\n\
    <method name=\"Stop\">\n\
    </method>\n\
    <method name=\"Play\">\n\
    </method>\n\
    <method name=\"Repeat\">\n\
      <arg name=\"State\" type=\"b\" direction=\"in\"/>\n\
    </method>\n\
    <method name=\"GetStatus\">\n\
      <arg type=\"(iiii)\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"GetMetadata\">\n\
      <arg type=\"a{sv}\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"GetCaps\">\n\
      <arg type=\"i\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"VolumeSet\">\n\
      <arg name=\"Volume\" type=\"i\" direction=\"in\"/>\n\
    </method>\n\
    <method name=\"VolumeGet\">\n\
      <arg type=\"i\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"PositionSet\">\n\
      <arg name=\"Position\" type=\"i\" direction=\"in\"/>\n\
    </method>\n\
    <method name=\"PositionGet\">\n\
      <arg type=\"i\" direction=\"out\"/>\n\
    </method>\n\
  </interface>\n\
</node>";

const char* MPRIS_TRACKLIST_XML="<!DOCTYPE node PUBLIC \"-//freedesktop//DTD D-BUS Object Introspection 1.0//EN\"\n\
\"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd\">\n\
<node>\n\
  <interface name=\"org.freedesktop.DBus.Introspectable\">\n\
    <method name=\"Introspect\">\n\
      <arg name=\"introspection_xml\" direction=\"out\" type=\"s\"/>\n\
    </method>\n\
  </interface>\n\
  <interface name=\"org.freedesktop.MediaPlayer\">\n\
    <signal name=\"TrackListChange\">\n\
      <arg name=\"Nb_Tracks\" type=\"i\" direction=\"out\"/>\n\
    </signal>\n\
    <method name=\"AddTrack\">\n\
      <arg type=\"i\" direction=\"out\"/>\n\
      <arg name=\"Uri\" type=\"s\" direction=\"in\"/>\n\
      <arg name=\"PlayImmediately\" type=\"b\" direction=\"in\"/>\n\
    </method>\n\
    <method name=\"DelTrack\">\n\
      <arg name=\"Position\" type=\"i\" direction=\"in\"/>\n\
    </method>\n\
    <method name=\"GetCurrentTrack\">\n\
      <arg type=\"i\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"GetLength\">\n\
      <arg type=\"i\" direction=\"out\"/>\n\
    </method>\n\
    <method name=\"GetMetadata\">\n\
      <arg type=\"a{sv}\" direction=\"out\"/>\n\
      <arg name=\"Position\" type=\"i\" direction=\"in\"/>\n\
    </method>\n\
    <method name=\"SetLoop\">\n\
      <arg name=\"State\" type=\"b\" direction=\"in\"/>\n\
    </method>\n\
    <method name=\"SetRandom\">\n\
      <arg name=\"State\" type=\"b\" direction=\"in\"/>\n\
    </method>\n\
  </interface>\n\
</node>";


